// See LICENSE for license details.
package sifive.freedom.unleashed.u500ml507devkit

import Chisel._

import freechips.rocketchip.config._
import freechips.rocketchip.subsystem._
import freechips.rocketchip.devices.debug._
import freechips.rocketchip.devices.tilelink._
import freechips.rocketchip.diplomacy._
import freechips.rocketchip.system._

import sifive.blocks.devices.gpio._
import sifive.blocks.devices.spi._
import sifive.blocks.devices.uart._
import sifive.blocks.devices.terminal._

import sifive.fpgashells.devices.xilinx.xilinxml507mig._

//-------------------------------------------------------------------------
// U500ML507DevKitSystem
//-------------------------------------------------------------------------

class U500ML507DevKitSystem(implicit p: Parameters) extends RocketSubsystem
    with HasPeripheryMaskROMSlave
    with HasPeripheryDebug
    with HasSystemErrorSlave
    with HasPeripheryUART
    with HasPeripheryTerminal
    with HasPeripherySPI
    with HasPeripheryGPIO
    with HasMemoryML507 {
  override lazy val module = new U500ML507DevKitSystemModule(this)
}

class U500ML507DevKitSystemModule[+L <: U500ML507DevKitSystem](_outer: L)
  extends RocketSubsystemModuleImp(_outer)
    with HasRTCModuleImp
    with HasPeripheryDebugModuleImp
    with HasPeripheryUARTModuleImp
    with HasPeripheryTerminalModuleImp
    with HasPeripherySPIModuleImp
    with HasPeripheryGPIOModuleImp
    with HasMemoryML507ModuleImp {
  // Reset vector is set to the location of the mask rom
  val maskROMParams = p(PeripheryMaskROMKey)
  global_reset_vector := maskROMParams(0).address.U
}
